program gr_h04; {    . }
{$APPTYPE    CONSOLE}
uses
  Graphics, Classes, SysUtils, jpeg;
const NA = 9; { #    }
type
  TInterp = procedure;  { p2 -> p3 }
  BMatrix = array of array of integer;
  RMatrix = array[0..NA, 0..NA] of extended;
  RVector = array[0..NA       ] of extended;

var p1, p2: BMatrix;
    mx, my, mx2, my2: integer;
    a : RVector;
    ma, ma0: RMatrix;
{
    res, rmin: extended;
    a: array[1..NA] of extended;
}
    f : Text;

{----------------------------------------------------------------------}
Procedure Read_Gr1( fname: string; var p: BMatrix);
var BitMap : TBitMap;
    jp     : TJpegImage;
    x,y    : integer;
    ext    : string[5];
    pl     : PByteArray;
begin
  p := nil;
  ext := UpperCase( ExtractFileExt(fname));
  if (ext <> '.BMP') and (ext <> '.JPG') and (ext <> '.JPEG') then Exit;
  BitMap := TBitMap.Create;
  try
    if UpperCase( ExtractFileExt(fname))= '.BMP' then
      BitMap.LoadFromFile(fname)
    else begin
      jp := TJpegImage.Create;
      jp.LoadFromFile(fname);
      BitMap.Assign(jp);
      jp.Free;
    end;
    my:=Bitmap.Height;  if odd(my) then dec(my);
    mx:=Bitmap.Width;   if odd(mx) then dec(mx);
    SetLength( p, mx+1,  my+1 );
    {     : Bitmap -> p1 }
    for y:= 0 to my-1 do begin
      pl := BitMap.ScanLine[y];
      for x:= 0 to mx-1 do
      p1[x,y] := (integer(pl[3*x]) + pl[3*x+1] + pl[3*x+2]) div 3;
    end;
  except
    on EFOpenError do p:=nil;
  end;
  BitMap.Free;
end;
{----------------------------------------------------------------------}
procedure AddLine;{   ma  sqr(a0 + a1*x1 + .. + an*xn)}
var i,j: integer;
begin
  for i:=0 to NA do
  for j:=0 to NA do ma[i,j] := ma[i,j] + a[i]*a[j];
end;
{---------------   p2  - -------------}
function vpk( k, x,y, dx, dy: integer ):byte;
begin
  case k of
  0 : vpk := p2[x+dx, y+dy];
  1 : vpk := p2[x+dx, y-dy];
  2 : vpk := p2[x-dx, y-dy];
  3 : vpk := p2[x-dx, y+dy];
  else vpk:= 0;
  end;
end;
{----------------------------------------------------------------------}
procedure Calc_A1( k, x,y, x1,y1: integer );
begin
  a[0] := -p1[x1,y1];
  a[1] := p2[x,y];
  a[2] := vpk( k, x,y, 0, 1 ) + vpk( k, x,y, 1, 0 );
  a[3] := vpk( k, x,y, 1, 1 );
  a[4] := vpk( k, x,y, 0,-1 ) + vpk( k, x,y,-1, 0 );
  a[5] := vpk( k, x,y, 1,-1 ) + vpk( k, x,y,-1, 1 );
  a[6] := vpk( k, x,y,-1,-1 ) + vpk( k, x,y, 0, 2 ) + vpk( k, x,y, 2, 0 );
  a[7] := vpk( k, x,y, 1, 2 ) + vpk( k, x,y, 2, 1 );
  a[8] := vpk( k, x,y,-1, 2 ) + vpk( k, x,y, 2,-1 );
  a[9] := vpk( k, x,y,-2, 0 ) + vpk( k, x,y, 0,-2 );
end;
{----------------------------------------------------------------------}
procedure LinSolv(var ma: RMAtrix; n: integer);
{  
     ma[1,0] + ma[1,1]*x[1] + .. + ma[1,n]*x[n] = 0
     ........
     ma[n,0] + ma[n,1]*x[1] + .. + ma[n,n]*x[n] = 0
      :
     ma[1,0] +         x[1]                     = 0
     ........
     ma[n,0] +                            x[n]  = 0
}
var i,j,k: integer;
    d: extended;
begin
  for k:=1 to n do begin
    d:=ma[k,k]; for j:= 0 to n do ma[k,j]:=ma[k,j]/d;
    for i:=1 to n do if i<> k then begin
      d := ma[i,k];
      for j:=0 to n do ma[i,j] := ma[i,j] - d*ma[k,j];
    end;
  end;
end;
{----------------------------------------------------------------------}
function RValue( var ma: RMAtrix; var a: RVector; n: integer): extended;
var i,j: integer;
    v: extended;
begin
  v:=0;
  for i:=0 to n do
  for j:=0 to n do v := v + ma[i,j]*a[i]*a[j];
  RValue := v;
end;
{----------------------------------------------------------------------}
procedure OneFile( fname: string );
var x,y,j,n: integer;
    ot0, otkl :extended;
begin
  Read_Gr1( fname, p1);
  {   : }
  my2 := my div 2;  mx2 := mx div 2; SetLength( p2, mx2+1,  my2+1 );
  for x:= 0 to mx2-1 do
  for y:= 0 to my2-1 do
    p2[x,y]:=(p1[2*x,  2*y] +p1[2*x,  2*y+1]+
              p1[2*x+1,2*y] +p1[2*x+1,2*y+1] ) div 4;

  ot0 := 0; {   }
  for x:= 2 to mx2-3 do
  for y:= 2 to my2-3 do
  ot0 := ot0 + sqr(p1[2*x,  2*y]- p2[x,y]) + sqr(p1[2*x,  2*y+1]- p2[x,y])+
               sqr(p1[2*x+1,2*y]- p2[x,y]) + sqr(p1[2*x+1,2*y+1]- p2[x,y]);
  ot0 := sqrt(ot0/(mx-8)/(my-8));
  for x:= 0 to NA do
  for y:= 0 to NA do ma[x,y]:=0;

  {    }
  for x:= 2 to mx2-3 do begin
    for y:= 2 to my2-3 do begin
      Calc_A1( 0, x,y, 2*x,   2*y   );   AddLine;
      Calc_A1( 1, x,y, 2*x,   2*y+1 );   AddLine;
      Calc_A1( 2, x,y, 2*x+1, 2*y+1 );   AddLine;
      Calc_A1( 3, x,y, 2*x+1, 2*y   );   AddLine;
    end;
  end;

  for x:= 0 to NA do
  for y:= 0 to NA do ma[x,y]:= ma[x,y]/(mx-8)/(my-8);

  Append(f);
  WriteLn( f, '---------->', fname );
  {   :
  for y:= 0 to NA do begin
    for x:= 0 to NA do Write( f, ma[x,y]:16:6, ',' );
    WriteLn( f );
  end;
  }
  ma0 := ma;
  for n:=1 to NA do begin
    ma:=ma0;
    LinSolv(ma, n);
    for y:= 1 to n do a[y] := -ma[y,0]; a[0]:= 1;
    otkl := sqrt( RValue( ma0, a, n ))/ot0;
    Write( f, 'n=', n, ' otkl=', otkl:10:6, ' a=' );
    for y:= 1 to n do Write( f, a[y]:12:6 );
    WriteLn( f );
  end;
  WriteLn( f );
  Close(f);
  {WriteLn('That''s all!');  ReadLn;}

end;

{----------------------------------------------------------------------}

var sr: TSearchRec;
    cou : integer;
    ext: string[5];
begin
  if ParamCount>0 then Assign( f, ParamStr(1))  else Assign( f, 'result.txt');
  Rewrite(f);
  WriteLn( f, 'Find optimal interpolation formula' );
  Close(f);
  cou:=0;
  if FindFirst('*.*', faAnyFile, sr) = 0 then
  repeat
    ext := UpperCase( ExtractFileExt(sr.Name));
    if (ext <> '.BMP') and (ext <> '.JPG') and (ext <> '.JPEG') then continue;
    WriteLn( sr.Name, #13 );
    OneFile( sr.Name );
    inc(cou);
    WriteLn( cou:8, AllocMemSize:10 );
  until FindNext(sr) <> 0;
  WriteLn( cou );

end.




